;(function() {
    if(window.WebViewJavascriptBridge) {
        return
    }
    //alert("JS enter")
	var messagingIframe
    var sendMessageQueue = []
	var receiveMessageQueue = []
	var messageHandlers = {}
	var CUSTOM_PROTOCOL_SCHEME = 'wvjbscheme'
	var QUEUE_HAS_MESSAGE = '__WVJB_QUEUE_MESSAGE__'
	var responseCallbacks = {}
	var uniqueId = 1

	function init(messageHandler) {
		if (WebViewJavascriptBridge._messageHandler) {
		    throw new Error('WebViewJavascriptBridge.init called twice')
		}
		//alert("JS init")
		WebViewJavascriptBridge._messageHandler = messageHandler
		var receivedMessages = receiveMessageQueue
		receiveMessageQueue = null
		for (var i=0; i<receivedMessages.length; i++) {
			_dispatchMessageFromObjC(receivedMessages[i])
		}
	}

	function send(data, responseCallback) {
		_doSend({ data:data }, responseCallback)
	}

    //H5进入页面先注册一个handler 用于同一页面多次回调H5使用或原生主动调H5使用
	function registerHandler(handlerName, handler) {
	    //alert("JS call : registerHandler")
		messageHandlers[handlerName] = handler
	}

    //H5单次回调方法 每次都传callback 缺点：只能来回通信一次
    //如果调用该方法注册了一个responseCallback但是responseCallback不是一个function则依旧会去用该responseCallback去执行方法
    //responseCallback不传或者传undefined则会使用 registerHandler注册的回调接口进行回调
	function callHandler(handlerName, data, responseCallback) {
	    //alert("JS call : callHandler")
		_doSend({ handlerName:handlerName, data:data }, responseCallback)
	}

    //开始下发消息
	function _doSend(message, responseCallback) {
		if (responseCallback) {
		    //H5传了callback才会生成callbackId
			var callbackId = 'cb_'+(uniqueId++)+'_'+new Date().getTime()
			responseCallbacks[callbackId] = responseCallback
			message['callbackId'] = callbackId
			console.log("_doSend callbackId:"+callbackId+"message:"+JSON.stringify(message)+"\nresponseCallback:"+responseCallback)
		}
		else{
		    console.log("_doSend nocallback:\n callbackId:"+callbackId+"message:"+JSON.stringify(message)+"\nresponseCallback:"+responseCallback)
		}
		sendMessageQueue.push(message)
		//原先的github上JSBridge源码是以shouldOverrideUrlLoading执行接口(如下 可防止4.2JS漏洞) 公司内改为了Object接口形式
		//messagingIframe.src = CUSTOM_PROTOCOL_SCHEME + '://' + QUEUE_HAS_MESSAGE
		//调到原生的onActionEvent方法
		window.android.onActionEvent(_fetchQueue());
	}

	function _fetchQueue() {
	    //从下面的逻辑来看 每次sendMessageQueue[]里其实就一个对象
		var messageQueueString = JSON.stringify(sendMessageQueue)
		sendMessageQueue = []
		//alert("JS push : " + messageQueueString)
		return messageQueueString
	}

    //原生回调时执行的JS方法
	function _dispatchMessageFromObjC(messageJSON) {
		setTimeout(function _timeoutDispatchMessageFromObjC() {
			var message = JSON.parse(messageJSON)
			var messageHandler
			if (message.responseId) {
			    //H5调原生接口 并且原生需要callback回H5 用到responseId
				var responseCallback = responseCallbacks[message.responseId]
				if (!responseCallback) {
				    return;
				}
				//alert("JS callback : " + message.responseData)
				responseCallback(message.responseData)
				if(message.responseData){
				    //特殊逻辑：借贷页只有刚进入会触发一次接口调用 然后接口要重用 添加一个字段不让callback删除
				    //H5多次调用就没事 或者也可以先只注册handler 再通过handlerName来回传 (资产分析就是这样)
                	var notDelCallback = message.responseData['notDelCallback']
                	if(!notDelCallback){
                	    delete responseCallbacks[message.responseId]
                	}
                }else{
                	delete responseCallbacks[message.responseId]
               }
			} else {
			    //原生主动调H5接口 如果需要H5callback回原生 要用到callbackId 目前还不支持 要重写WebviewJavaScriptBridge逻辑
				var responseCallback
				if (message.callbackId) {
				    //原生onActionCallBack()时带上callbackId H5拿到handler给function写回时
				    //会继续下发到_doSend() { responseId:responseId, data:data }
				    //自己在接口map里注册一个以responseId为名字的接口接收即可(注意不用再原生onActionCallBack()写回了！)
					var callbackResponseId = message.callbackId
					responseCallback = function(responseData) {
					    //注意只有message，没有responseCallback的
						_doSend({ responseId:callbackResponseId, responseData:responseData })
					}
				}
                //H5前面注册了registerHandler 原生用handlerName找到handler并回调
				var handler = WebViewJavascriptBridge._messageHandler
				if (message.handlerName) {
					handler = messageHandlers[message.handlerName]
				}
				try {
				    //alert(JS findHandler : message.handlerName + " , " + message.responseData)
					handler(message.responseData, responseCallback)
				} catch(exception) {
					if (typeof console != 'undefined') {
						console.log("WebViewJavascriptBridge: WARNING: javascript handler threw."+message+"|"+exception.message+"|"+(exception.stack))
						console.log("JS findHandler :"+ message.handlerName + " , " + JSON.stringify(message.responseData))
					}
				}
			}
		})
	}

	function _handleMessageFromObjC(messageJSON) {
		if (receiveMessageQueue) {
			receiveMessageQueue.push(messageJSON)
		} else {
			_dispatchMessageFromObjC(messageJSON)
		}
	}

	window.WebViewJavascriptBridge = {
		init: init,
		send: send,
		registerHandler: registerHandler,//H5仅注册原生监听回调
		callHandler: callHandler,//H5主动调原生并监听回调
		_fetchQueue: _fetchQueue,
		_handleMessageFromObjC: _handleMessageFromObjC
	}

	var doc = document
	var readyEvent = doc.createEvent('Events')
	readyEvent.initEvent('WebViewJavascriptBridgeReady')
	readyEvent.bridge = WebViewJavascriptBridge
	doc.dispatchEvent(readyEvent)

	})();
