function setupWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }
    if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
    window.WVJBCallbacks = [callback];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'https://__bridge_loaded__';
    document.documentElement.appendChild(WVJBIframe);
    setTimeout(function() { document.documentElement.removeChild(WVJBIframe) }, 0)
}

var hashActivePhone = "#!/account/activePhone.html";
var hashLogin = "#!/account/login.html";

function modifyUI(){
    try{
        if(!document.getElementById('hexin_stock_toast') && window.location.hash == hashLogin){
            var div=document.createElement("div");
            div.innerHTML= '<p id="hexin_stock_toast">数据同步前需要进行信息校验</p>'
            div.style.textAlign='center';
            div.style.background='#F7C342';
            var des = document.getElementsByClassName('input_form login_form')[0]
            des.parentElement.insertBefore(div,des)
        }
        //去除标题
        var headers = document.getElementsByTagName('header')
        for(var header of Array.prototype.slice.call(headers)){
            header.style.display = 'none';
        }
        //默认勾选记住账号-实际可能未生效
        document.getElementById('saveAcc').style.display='none'
        //验证码弹窗引号去除
        var questions = document.getElementsByClassName('yidun_feedback');
        for(var question of Array.prototype.slice.call(questions)){
            question.style.display='none'
        }

    }catch(e){
        //失败不用管
    }
}

try{
    //页面UI适配
}catch(e){
    //失败不用管
}

//普通打印
function sendNativeLog(e){
    setupWebViewJavascriptBridge(function(bridge) {
                                 bridge.callHandler("sendNativeLog", e)
                                 });
}

//异常回调
//function sendNativeError(e){
//    setupWebViewJavascriptBridge(function(bridge) {
//                                 bridge.callHandler("sendNativeError", e)
//                                 });
//}

//本地数据回调
//function sendNativeMessage(m){
//    setupWebViewJavascriptBridge(function(bridge) {
//                                 bridge.callHandler("sendNativeMessage", m)
//                                 });
//}

//获取用户登录参数
function sendLoginParams(){
    var account = document.getElementById('account').value
    var password = document.getElementById('password').value

    sendNativeMessage({
                      "hexin_stock_username":account,
                      "hexin_stock_password":password
                      });
};

////获取点击下一步时参数
//function sendNextParams(){
//    var phone = document.getElementById('phoneNum').value
//
//    sendNativeMessage({
//                      "hexin_stock_phone":phone
//                      });
//};


//监听按钮点击，按钮点击时获取账号密码，并回调给native
function monitorLoginClick(){
    var loginBtn = document.getElementById('login');

    if(loginBtn && !loginBtn.onclick){//避免重复监听
        loginBtn.onclick=sendLoginParams;
    }
}

//function monitorNextClick(){
//    var nextBtn = document.getElementById('next');
//
//    if(nextBtn && !nextBtn.onclick){//避免重复监听
//        nextBtn.onclick=sendNextParams;
//    }
//}

window.bEvaluateLoginParams = false;//仅注入一次，避免中间环节页面加载导致异常

function evaluateLoginParams(){

    //非登录页清除注入标志位
    if(window.location.hash != hashLogin){//猜测覆盖同步结果页没有注入是这个原因导致 登录页->手机号页->登录页 再进入登录页时原本注入内容被清空了
        window.bEvaluateLoginParams = false;
        return;
    }

    var accountInput = document.getElementById("account");
    var passwordInput = document.getElementById("password");

    if(!accountInput || !passwordInput || bEvaluateLoginParams){
        return;
    }

    function tryEvaluate(){
        try{//客户端替换字段不可控，故加保护
            var u = "$hexin_stock_username$";
            var p = "$hexin_stock_password$";
            var bind = "$hexin_stock_bind_flag$";

            if(u.indexOf("$hexin_stock") < 0){
                document.getElementById("account").value = u;
                if(bind == String(false)){
                    document.getElementById('account').readOnly=true;
                    document.getElementsByClassName('input_text j_login')[0].style.display="none";
                }
            }
            if(p.indexOf("$hexin_stock") < 0){
                document.getElementById("password").value = p;
            }

            window.bEvaluateLoginParams = true;
        } catch(e){
            sendNativeLog(e);
        }
    }

    setTimeout(tryEvaluate,1000);//元素出现后直接注入账号密码，依旧会被清空，原因未知
}

//监听页面跳转到登录页，页面跳转到登录页且流程未终止意味着流程异常
//try{
function monitorNavigateToLogin(){
    try{
        if(window.location.hash == '#!/account/index.html' && !window.isLoginSuccess){
            sendNativeError({code:-1,message:'页面跳转异常'});
            window.isLoginSuccess = true;
        }
    }catch(e){
        sendNativeLog(e)
    }
}

window.isLoginSuccess = false;
//    setInterval(monitorNavigateToLogin, 500);
//}catch(e){
//    sendNativeLog('wtf!!!!!!!!')
//}

//每次页面元素变化，都会调用次方法
function domNodeInsert()
{
    modifyUI();
    monitorLoginClick();
    //    monitorNextClick();
    evaluateLoginParams();
    monitorNavigateToLogin();
}

document.addEventListener("DOMNodeInserted", domNodeInsert);//监听所有页面元素变动
domNodeInsert();//感觉这么写帅的一比

//try{
//    localStorage.removeItem('deal|ordSavaAcc');
//}catch(e){
//    sendNativeLog(e);
//}
//document.getElementById('saveAcc').children[0].click()//记住密码
//document.getElementsByTagName('header')[0].style.display = 'none'导航栏清除

//function setupWebViewJavascriptBridge(callback) {
//    if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }
//    if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
//    window.WVJBCallbacks = [callback];
//    var WVJBIframe = document.createElement('iframe');
//    WVJBIframe.style.display = 'none';
//    WVJBIframe.src = 'https://__bridge_loaded__';
//    document.documentElement.appendChild(WVJBIframe);
//    setTimeout(function() { document.documentElement.removeChild(WVJBIframe) }, 0)
//}

//window.addEventListener("hashchange", function(){alert('hashchange')}, false)
//window.hasGetCookie = false;
//
//setInterval(function(){
//            if(!window.hasGetCookie && location.hash == "#!/account/index.html"){
//                window.hasGetCookie = true
//                setupWebViewJavascriptBridge(function(bridge) {
//                                             bridge.callHandler('triggerGetCookie')
//                                             })
//            }
//            },0.1)

//if(!window.onhashchange){
//    window.onhashchange = function (){
//        alert('hash change')
//        if(location.hash == "#!/account/index.html"){
//            setupWebViewJavascriptBridge(function(bridge) {
//                                         bridge.callHandler('triggerGetCookie')
//                                         })
//        }
//    }
//}

//window.location.href = "https://weixin.citicsinfo.com/tztweb/deal/index.html#!/account/index.html"
//window.location.href = "https://weixin.citicsinfo.com/tztweb/deal/index.html#!/account/login.html"

//获取js中字段
//document.getElementById('account').value = '123123'
//password = document.getElementById('password').value = '4567889'
//document.getElementsByClassName('ce_btn')[0].children[0].click();

//页面控制TODO
//注入账号密码TODO

//先使用延时，后续再做更改TODO






//异常回调  fgd
function sendNativeError(e){
//    setupWebViewJavascriptBridge(function(bridge) {
//                                 bridge.callHandler("sendNativeError", e)
//                                 });

    dsBridge.call("onWebNativeError", e);
}

//本地数据回调 fgd
function sendNativeMessage(m){
//    setupWebViewJavascriptBridge(function(bridge) {
//                                 bridge.callHandler("sendNativeMessage", m)
//                                 });

    dsBridge.call("receiveAccountInfo", m);
}
